#!/usr/bin/perl -w
# Xmsgd 
# Copyright (C) 2001 Thomas Vander Stichele <thomas@apestaart.org>
# 
# msgclient.pl: client for msgd.pl, tailing your log file
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
#
# be a client to msgd.pl
# write lines to a socket
# this trial version takes lines from stdin
#
# with some simple regexp's, it chooses an output subsystem
#
# ideally, you would supply a config file describing what file to get data
# from and regexps determining subsystem

# configure regexp's

%regexp = (
  "log-critical" => [ "restart", "failure" ],
  "log-problem"  => [ "error" ],
  "log-warning"  => [ "last message repeated", "user root" ]
);

$fifo = "/usr/share/Xmsgd/msgd.fifo";

$file = $ARGV[0];

if ($file)
{
  require $file;
}

#open FILE, $file or die "Cannot open file $file : $!\n";
open OUTPUT, ">$fifo" or die "Cannot open output $fifo : $!\n";

select((select(OUTPUT), $| = 1)[0]);

# first output all the stuff that's already there
#print "skipping lines that are already there.\n";

# now tail it
while (1)
{
#print "tail loop.\n";
sleep 1;
while ($line = <STDIN>)
{
  #print "got line : $line\n";
  $subsys = "log-info";
  # look up regexps
  foreach $subsys_cand (keys %regexp)
  {
    foreach $re (@ {$regexp{$subsys_cand}})
    {
#      printf ("checking $line for $re...\n");
      if ($line =~ /$re/)
      {
        $subsys = $subsys_cand;
      }
    }
  }
# print "outputting $line to $subsys\n";
  print OUTPUT "$subsys $line";
}
}
