#!/usr/bin/perl -w
# Xmsgd 
# Copyright (C) 2001 Thomas Vander Stichele <thomas@apestaart.org>
# 
# msgdrandomd.pl: a random reminder daemon for Xmsgd 
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
#
# last changed : 20/08/2001
#

use Socket;
use IO::Handle;

my $PROGRAM = "msgrandomd";
my $MSGD_FIFO = "/usr/share/Xmsgd/msgd.fifo";
my $DEF_CONF_FILE = "/usr/share/Xmsgd/etc/$PROGRAM.conf";
my $CONF_DIR = `echo -n ~`."/.Xmsgd";
my $CONF_FILE = $CONF_DIR."/$PROGRAM.conf";

use vars qw(@messages $sleep_time);

if (! -e $MSGD_FIFO)
{
  print "msgd socket $MSGD_FIFO does not exist ! Please re-install.\n";
  exit;
}

if (! -d $CONF_DIR)
{
  print "Configuration directory $CONF_DIR does not exist, creating ...\n";
  system ("mkdir -p $CONF_DIR") and die "Could not create $CONF_DIR !";
}

if (! -e $CONF_FILE)
{
  print "You do not have the config file $CONF_FILE.\n";
  print "I will copy it for you from $DEF_CONF_FILE.\nPlease edit it.\n";
  system ("cp $DEF_CONF_FILE $CONF_FILE")
    and die "Could not copy $DEF_CONF_FILE !";
  exit;
}

require $CONF_FILE or die "Please create the config file $CONF_FILE";

# start with a fork
if (fork ())
{
  exit;
}

# check if msgd.pl is running

$command = "ps h -C msgd.pl";
$result = `$command`;
if (!$result)
{
  system ("msgd.pl");
}

while (1)
{
  my $line = rand scalar (@messages);
  #print "outputting $messages[$line]\n";
  my $command = "echo reminder $messages[$line] > $MSGD_FIFO";
  #print "executing $command\n";
  system $command;
  sleep $sleep_time;
}

